//+------------------------------------------------------------------+
//|                                ADX PSAR MTF Signal Indicator.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Adam  2016: Dragon"
#property link      "do your homework mate..."

#property indicator_chart_window

int tframe[]={1,5,15,30,60,240,1440,10080,43200};
string tf[]={"M1","M5","M15","M30","H1","H4","D1","W1","MN1"};
int tfnumber=9;    

extern string  Indi_Setting   ="=== Indicator Setup ===";
extern int     ADX_Period     =  9;
extern int     ADX_Price      =  PRICE_CLOSE;
extern double  Step_Psar      =  0.09;
extern double  Max_Psar       =  0.2;
extern string  pairname1      =  "USDCHF";
extern string  pairname2      =  "USDJPY";
extern string  pairname3      =  "USDCAD";
extern string  pairname4      =  "EURUSD";
extern string  pairname5      =  "EURGBP";
extern string  pairname6      =  "EURJPY";
extern string  pairname7      =  "EURAUD";
extern string  pairname8      =  "EURCHF";
extern string  pairname9      =  "EURCAD";
extern string  pairname10      =  "EURNZD";
extern string  pairname11      =  "GBPUSD";
extern string  pairname12      =  "GBPJPY";
extern string  pairname13      =  "GBPCHF";
extern string  pairname14      =  "GBPAUD";
extern string  pairname15      =  "GBPCAD";
extern string  pairname16      =  "GBPNZD";
extern string  pairname17      =  "AUDUSD";
extern string  pairname18      =  "AUDJPY";
extern string  pairname19      =  "AUDCAD";
extern string  pairname20      =  "AUDCHF";
extern string  pairname21      =  "AUDNZD";
extern string  pairname22      =  "CADJPY";
extern string  pairname23      =  "CADCHF";
extern string  pairname24      =  "CHFJPY";
extern string  pairname25      =  "NZDUSD";
extern string  pairname26      =  "NZDJPY";
extern string  pairname27      =  "NZDCAD";
extern string  pairname28      =  "NZDCHF";

extern string  Draw_Setting  ="=== Draw Parameters ===";
extern int     PosXstart      =  10;
extern int     PosXstep       =  24;
extern int     PosYstart      =  15;
extern int     PosYstep       =  15;
extern color   UpColor        =  Lime;
extern color   DownColor      =  Red;
extern color   FlatColor      =  Yellow;
extern color   TextColor      =  Aqua;
extern int     Corner         =  1;

double         Psar1,Psar2,Psar3,Psar4,Psar5,Psar6,Psar7,Psar8,Psar9,Psar10,Psar11,Psar12,Psar13,Psar14,Psar15,Psar16,Psar17,Psar18,Psar19,Psar20,Psar21,Psar22,Psar23,Psar24,Psar25,Psar26,Psar27,Psar28;
double         PADX1,PADX2,PADX3,PADX4,PADX5,PADX6,PADX7,PADX8,PADX9,PADX10,PADX11,PADX12,PADX13,PADX14,PADX15,PADX16,PADX17,PADX18,PADX19,PADX20,PADX21,PADX22,PADX23,PADX24,PADX25,PADX26,PADX27,PADX28;
double         NADX1,NADX2,NADX3,NADX4,NADX5,NADX6,NADX7,NADX8,NADX9,NADX10,NADX11,NADX12,NADX13,NADX14,NADX15,NADX16,NADX17,NADX18,NADX19,NADX20,NADX21,NADX22,NADX23,NADX24,NADX25,NADX26,NADX27,NADX28;
string         TimeFrameStr;
double         IndVal1[9],IndVal2[9],IndVal3[9],IndVal4[9],IndVal5[9],IndVal6[9],IndVal7[9],IndVal8[9],IndVal9[9],IndVal10[9],IndVal11[9],IndVal12[9],IndVal13[9],IndVal14[9],IndVal15[9],IndVal16[9],IndVal17[9],IndVal18[9],IndVal19[9],IndVal20[9],IndVal21[9],IndVal22[9],IndVal23[9],IndVal24[9],IndVal25[9],IndVal26[9],IndVal27[9],IndVal28[9];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   ushort u_sep=StringGetCharacter(",",0);
   if       (Corner==1 || Corner==3)
            {
            ArraySort(tframe,WHOLE_ARRAY,0,MODE_DESCEND);
            //tframe[9]   ={43200,10080,1440,240,60,30,15,5,1};
            //tf[9]       ={"MN1","W1","D1","H4","H1","M30","M15","M5","M1"};
            StringSplit("MN1,W1,D1,H4,H1,M30,M15,M5,M1",u_sep,tf);
            }
   else if  (Corner==0 || Corner==2)
            {
            ArraySort(tframe,WHOLE_ARRAY,0,MODE_ASCEND);
            //tframe[9]   ={1,5,15,30,60,240,1440,10080,43200};
            //tf[9]       ={"M1","M5","M15","M30","H1","H4","D1","W1","MN1"};
            StringSplit("M1,M5,M15,M30,H1,H4,D1,W1,MN1",u_sep,tf);
            }          
   
   for(int w=1;w<tfnumber+1;w++)
      {
         ObjectCreate   (tf[w-1],OBJ_LABEL,0,0,0,0,0);
         ObjectSet      (tf[w-1],OBJPROP_CORNER,Corner);
         ObjectSet      (tf[w-1],OBJPROP_XDISTANCE,(w-1)*PosXstep+PosXstart);
         ObjectSet      (tf[w-1],OBJPROP_YDISTANCE,PosYstart);
         ObjectSetText  (tf[w-1],tf[w-1],7,"Tahoma",TextColor);
      }
         ObjectCreate   ("pair1",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair1",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair1",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair1",OBJPROP_YDISTANCE,PosYstart+PosYstep+3);
         ObjectSetText  ("pair1",pairname1,10,"Tahoma",TextColor);
         
         ObjectCreate   ("pair2",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair2",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair2",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair2",OBJPROP_YDISTANCE,PosYstart+(PosYstep*2)+3);
         ObjectSetText  ("pair2",pairname2,10,"Tahoma",TextColor);
         
         ObjectCreate   ("pair3",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair3",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair3",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair3",OBJPROP_YDISTANCE,PosYstart+(PosYstep*3)+3);
         ObjectSetText  ("pair3",pairname3,10,"Tahoma",TextColor); 
         
         ObjectCreate   ("pair4",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair4",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair4",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair4",OBJPROP_YDISTANCE,PosYstart+(PosYstep*4)+3);
         ObjectSetText  ("pair4",pairname4,10,"Tahoma",TextColor);  
         
         ObjectCreate   ("pair5",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair5",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair5",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair5",OBJPROP_YDISTANCE,PosYstart+(PosYstep*5)+3);
         ObjectSetText  ("pair5",pairname5,10,"Tahoma",TextColor);    
         
         ObjectCreate   ("pair6",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair6",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair6",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair6",OBJPROP_YDISTANCE,PosYstart+(PosYstep*6)+3);
         ObjectSetText  ("pair6",pairname6,10,"Tahoma",TextColor); 
         
         ObjectCreate   ("pair7",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair7",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair7",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair7",OBJPROP_YDISTANCE,PosYstart+(PosYstep*7)+3);
         ObjectSetText  ("pair7",pairname7,10,"Tahoma",TextColor); 
         
         ObjectCreate   ("pair8",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair8",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair8",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair8",OBJPROP_YDISTANCE,PosYstart+(PosYstep*8)+3);
         ObjectSetText  ("pair8",pairname8,10,"Tahoma",TextColor); 
         
         ObjectCreate   ("pair9",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair9",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair9",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair9",OBJPROP_YDISTANCE,PosYstart+(PosYstep*9)+3);
         ObjectSetText  ("pair9",pairname9,10,"Tahoma",TextColor); 

         ObjectCreate   ("pair10",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair10",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair10",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair10",OBJPROP_YDISTANCE,PosYstart+(PosYstep*10)+3);
         ObjectSetText  ("pair10",pairname10,10,"Tahoma",TextColor);
         
         ObjectCreate   ("pair11",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair11",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair11",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair11",OBJPROP_YDISTANCE,PosYstart+(PosYstep*11)+3);
         ObjectSetText  ("pair11",pairname11,10,"Tahoma",TextColor);

         ObjectCreate   ("pair12",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair12",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair12",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair12",OBJPROP_YDISTANCE,PosYstart+(PosYstep*12)+3);
         ObjectSetText  ("pair12",pairname12,10,"Tahoma",TextColor);

         ObjectCreate   ("pair13",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair13",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair13",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair13",OBJPROP_YDISTANCE,PosYstart+(PosYstep*13)+3);
         ObjectSetText  ("pair13",pairname13,10,"Tahoma",TextColor);

         ObjectCreate   ("pair14",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair14",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair14",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair14",OBJPROP_YDISTANCE,PosYstart+(PosYstep*14)+3);
         ObjectSetText  ("pair14",pairname14,10,"Tahoma",TextColor);

         ObjectCreate   ("pair15",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair15",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair15",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair15",OBJPROP_YDISTANCE,PosYstart+(PosYstep*15)+3);
         ObjectSetText  ("pair15",pairname15,10,"Tahoma",TextColor);
          
         ObjectCreate   ("pair16",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair16",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair16",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair16",OBJPROP_YDISTANCE,PosYstart+(PosYstep*16)+3);
         ObjectSetText  ("pair16",pairname16,10,"Tahoma",TextColor);

         ObjectCreate   ("pair17",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair17",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair17",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair17",OBJPROP_YDISTANCE,PosYstart+(PosYstep*17)+3);
         ObjectSetText  ("pair17",pairname17,10,"Tahoma",TextColor);

         ObjectCreate   ("pair18",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair18",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair18",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair18",OBJPROP_YDISTANCE,PosYstart+(PosYstep*18)+3);
         ObjectSetText  ("pair18",pairname18,10,"Tahoma",TextColor);

         ObjectCreate   ("pair19",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair19",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair19",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair19",OBJPROP_YDISTANCE,PosYstart+(PosYstep*19)+3);
         ObjectSetText  ("pair19",pairname19,10,"Tahoma",TextColor);

         ObjectCreate   ("pair20",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair20",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair20",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair20",OBJPROP_YDISTANCE,PosYstart+(PosYstep*20)+3);
         ObjectSetText  ("pair20",pairname20,10,"Tahoma",TextColor);

         ObjectCreate   ("pair21",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair21",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair21",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair21",OBJPROP_YDISTANCE,PosYstart+(PosYstep*21)+3);
         ObjectSetText  ("pair21",pairname21,10,"Tahoma",TextColor);

         ObjectCreate   ("pair22",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair22",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair22",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair22",OBJPROP_YDISTANCE,PosYstart+(PosYstep*22)+3);
         ObjectSetText  ("pair22",pairname22,10,"Tahoma",TextColor);

         ObjectCreate   ("pair23",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair23",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair23",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair23",OBJPROP_YDISTANCE,PosYstart+(PosYstep*23)+3);
         ObjectSetText  ("pair23",pairname23,10,"Tahoma",TextColor);

         ObjectCreate   ("pair24",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair24",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair24",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair24",OBJPROP_YDISTANCE,PosYstart+(PosYstep*24)+3);
         ObjectSetText  ("pair24",pairname24,10,"Tahoma",TextColor);

         ObjectCreate   ("pair25",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair25",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair25",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair25",OBJPROP_YDISTANCE,PosYstart+(PosYstep*25)+3);
         ObjectSetText  ("pair25",pairname25,10,"Tahoma",TextColor);

         ObjectCreate   ("pair26",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair26",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair26",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair26",OBJPROP_YDISTANCE,PosYstart+(PosYstep*26)+3);
         ObjectSetText  ("pair26",pairname26,10,"Tahoma",TextColor);

         ObjectCreate   ("pair27",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair27",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair27",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair27",OBJPROP_YDISTANCE,PosYstart+(PosYstep*27)+3);
         ObjectSetText  ("pair27",pairname27,10,"Tahoma",TextColor);

         ObjectCreate   ("pair28",OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("pair28",OBJPROP_CORNER,Corner);
         ObjectSet      ("pair28",OBJPROP_XDISTANCE,tfnumber*PosXstep+PosXstart);
         ObjectSet      ("pair28",OBJPROP_YDISTANCE,PosYstart+(PosYstep*28)+3);
         ObjectSetText  ("pair28",pairname28,10,"Tahoma",TextColor);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

   for   (int k=1;k<tfnumber+1;k++) 
         {  
            ObjectDelete("Ind"+k+pairname1);
            ObjectDelete("Ind"+k+pairname2);
            ObjectDelete("Ind"+k+pairname3);
            ObjectDelete("Ind"+k+pairname4);
            ObjectDelete("Ind"+k+pairname5);
            ObjectDelete("Ind"+k+pairname6);
            ObjectDelete("Ind"+k+pairname7);
            ObjectDelete("Ind"+k+pairname8);
            ObjectDelete("Ind"+k+pairname9);
            ObjectDelete("Ind"+k+pairname10);
            ObjectDelete("Ind"+k+pairname11);
            ObjectDelete("Ind"+k+pairname12);
            ObjectDelete("Ind"+k+pairname13);
            ObjectDelete("Ind"+k+pairname14);
            ObjectDelete("Ind"+k+pairname15);
            ObjectDelete("Ind"+k+pairname16);
            ObjectDelete("Ind"+k+pairname17);
            ObjectDelete("Ind"+k+pairname18);
            ObjectDelete("Ind"+k+pairname19);
            ObjectDelete("Ind"+k+pairname20);
            ObjectDelete("Ind"+k+pairname21);  
            ObjectDelete("Ind"+k+pairname22);
            ObjectDelete("Ind"+k+pairname23);
            ObjectDelete("Ind"+k+pairname24);
            ObjectDelete("Ind"+k+pairname25);
            ObjectDelete("Ind"+k+pairname26);
            ObjectDelete("Ind"+k+pairname27);
            ObjectDelete("Ind"+k+pairname28);
           
         }
   
   for   (k=1;k<tfnumber+1;k++)     
         {
            ObjectDelete(tf[k-1]);
         }
            ObjectDelete("pair1");
            ObjectDelete("pair2");   
            ObjectDelete("pair3");
            ObjectDelete("pair4"); 
            ObjectDelete("pair5");
            ObjectDelete("pair6");   
            ObjectDelete("pair7");
            ObjectDelete("pair8"); 
            ObjectDelete("pair9");
            ObjectDelete("pair10"); 
            ObjectDelete("pair11");
            ObjectDelete("pair12");   
            ObjectDelete("pair13");
            ObjectDelete("pair14"); 
            ObjectDelete("pair15");
            ObjectDelete("pair16");   
            ObjectDelete("pair17");
            ObjectDelete("pair18"); 
            ObjectDelete("pair19");
            ObjectDelete("pair20");
            ObjectDelete("pair21");
            ObjectDelete("pair22");   
            ObjectDelete("pair23");
            ObjectDelete("pair24"); 
            ObjectDelete("pair25");
            ObjectDelete("pair26");   
            ObjectDelete("pair27");
            ObjectDelete("pair28"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//----
   //delete/refresh objects begin
   for   (int a=1;a<tfnumber+1;a++) 
         {
            ObjectDelete("Ind"+a+pairname1);
            ObjectDelete("Ind"+a+pairname2);
            ObjectDelete("Ind"+a+pairname3);
            ObjectDelete("Ind"+a+pairname4);
            ObjectDelete("Ind"+a+pairname5);
            ObjectDelete("Ind"+a+pairname6);
            ObjectDelete("Ind"+a+pairname7);
            ObjectDelete("Ind"+a+pairname8);
            ObjectDelete("Ind"+a+pairname9);
            ObjectDelete("Ind"+a+pairname10);   
            ObjectDelete("Ind"+a+pairname11);
            ObjectDelete("Ind"+a+pairname12);
            ObjectDelete("Ind"+a+pairname13);
            ObjectDelete("Ind"+a+pairname14);
            ObjectDelete("Ind"+a+pairname15);
            ObjectDelete("Ind"+a+pairname16);
            ObjectDelete("Ind"+a+pairname17);
            ObjectDelete("Ind"+a+pairname18);
            ObjectDelete("Ind"+a+pairname19);
            ObjectDelete("Ind"+a+pairname20);
            ObjectDelete("Ind"+a+pairname21);
            ObjectDelete("Ind"+a+pairname22);
            ObjectDelete("Ind"+a+pairname23);
            ObjectDelete("Ind"+a+pairname24);
            ObjectDelete("Ind"+a+pairname25);
            ObjectDelete("Ind"+a+pairname26);
            ObjectDelete("Ind"+a+pairname27);
            ObjectDelete("Ind"+a+pairname28);
         }   
   //deleta/refresh object end

   //draw the base objects begin
   for(int j=1;j<tfnumber+1;j++)
      {
         ObjectCreate   ("Ind"+j+pairname1,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname1,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname1,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname1,OBJPROP_YDISTANCE,PosYstart+PosYstep);
         ObjectSetText  ("Ind"+j+pairname1,CharToStr(120),25,"Wingdings",White);
      
         ObjectCreate   ("Ind"+j+pairname2,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname2,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname2,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname2,OBJPROP_YDISTANCE,PosYstart+(PosYstep*2));
         ObjectSetText  ("Ind"+j+pairname2,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname3,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname3,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname3,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname3,OBJPROP_YDISTANCE,PosYstart+(PosYstep*3));
         ObjectSetText  ("Ind"+j+pairname3,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname4,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname4,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname4,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname4,OBJPROP_YDISTANCE,PosYstart+(PosYstep*4));
         ObjectSetText  ("Ind"+j+pairname4,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname5,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname5,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname5,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname5,OBJPROP_YDISTANCE,PosYstart+(PosYstep*5));
         ObjectSetText  ("Ind"+j+pairname5,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname6,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname6,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname6,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname6,OBJPROP_YDISTANCE,PosYstart+(PosYstep*6));
         ObjectSetText  ("Ind"+j+pairname6,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname7,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname7,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname7,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname7,OBJPROP_YDISTANCE,PosYstart+(PosYstep*7));
         ObjectSetText  ("Ind"+j+pairname7,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname8,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname8,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname8,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname8,OBJPROP_YDISTANCE,PosYstart+(PosYstep*8));
         ObjectSetText  ("Ind"+j+pairname8,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname9,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname9,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname9,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname9,OBJPROP_YDISTANCE,PosYstart+(PosYstep*9));
         ObjectSetText  ("Ind"+j+pairname9,CharToStr(120),25,"Wingdings",White);
       
         ObjectCreate   ("Ind"+j+pairname10,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname10,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname10,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname10,OBJPROP_YDISTANCE,PosYstart+(PosYstep*10));
         ObjectSetText  ("Ind"+j+pairname10,CharToStr(120),25,"Wingdings",White);
      
         ObjectCreate   ("Ind"+j+pairname11,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname11,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname11,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname11,OBJPROP_YDISTANCE,PosYstart+(PosYstep*11));
         ObjectSetText  ("Ind"+j+pairname11,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname12,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname12,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname12,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname12,OBJPROP_YDISTANCE,PosYstart+(PosYstep*12));
         ObjectSetText  ("Ind"+j+pairname12,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname13,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname13,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname13,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname13,OBJPROP_YDISTANCE,PosYstart+(PosYstep*13));
         ObjectSetText  ("Ind"+j+pairname13,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname14,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname14,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname14,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname14,OBJPROP_YDISTANCE,PosYstart+(PosYstep*14));
         ObjectSetText  ("Ind"+j+pairname14,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname15,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname15,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname15,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname15,OBJPROP_YDISTANCE,PosYstart+(PosYstep*15));
         ObjectSetText  ("Ind"+j+pairname15,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname16,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname16,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname16,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname16,OBJPROP_YDISTANCE,PosYstart+(PosYstep*16));
         ObjectSetText  ("Ind"+j+pairname16,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname17,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname17,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname17,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname17,OBJPROP_YDISTANCE,PosYstart+(PosYstep*17));
         ObjectSetText  ("Ind"+j+pairname17,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname18,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname18,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname18,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname18,OBJPROP_YDISTANCE,PosYstart+(PosYstep*18));
         ObjectSetText  ("Ind"+j+pairname18,CharToStr(120),25,"Wingdings",White);
        
         ObjectCreate   ("Ind"+j+pairname19,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname19,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname19,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname19,OBJPROP_YDISTANCE,PosYstart+(PosYstep*19));
         ObjectSetText  ("Ind"+j+pairname19,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname20,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname20,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname20,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname20,OBJPROP_YDISTANCE,PosYstart+(PosYstep*20));
         ObjectSetText  ("Ind"+j+pairname20,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname21,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname21,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname21,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname21,OBJPROP_YDISTANCE,PosYstart+(PosYstep*21));
         ObjectSetText  ("Ind"+j+pairname21,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname22,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname22,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname22,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname22,OBJPROP_YDISTANCE,PosYstart+(PosYstep*22));
         ObjectSetText  ("Ind"+j+pairname22,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname23,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname23,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname23,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname23,OBJPROP_YDISTANCE,PosYstart+(PosYstep*23));
         ObjectSetText  ("Ind"+j+pairname23,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname24,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname24,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname24,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname24,OBJPROP_YDISTANCE,PosYstart+(PosYstep*24));
         ObjectSetText  ("Ind"+j+pairname24,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname25,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname25,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname25,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname25,OBJPROP_YDISTANCE,PosYstart+(PosYstep*25));
         ObjectSetText  ("Ind"+j+pairname25,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname26,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname26,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname26,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname26,OBJPROP_YDISTANCE,PosYstart+(PosYstep*26));
         ObjectSetText  ("Ind"+j+pairname26,CharToStr(120),25,"Wingdings",White);

         ObjectCreate   ("Ind"+j+pairname27,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname27,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname27,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname27,OBJPROP_YDISTANCE,PosYstart+(PosYstep*27));
         ObjectSetText  ("Ind"+j+pairname27,CharToStr(120),25,"Wingdings",White);
         
         ObjectCreate   ("Ind"+j+pairname28,OBJ_LABEL,0,0,0,0,0);
         ObjectSet      ("Ind"+j+pairname28,OBJPROP_CORNER,Corner);
         ObjectSet      ("Ind"+j+pairname28,OBJPROP_XDISTANCE,(j-1)*PosXstep+PosXstart);
         ObjectSet      ("Ind"+j+pairname28,OBJPROP_YDISTANCE,PosYstart+(PosYstep*28));
         ObjectSetText  ("Ind"+j+pairname28,CharToStr(120),25,"Wingdings",White);
      }
      //draw the base objects end
    
   for(int x=1;x<tfnumber+1;x++)
      {
      // get indicators data begin
      PADX1=iADX  (pairname1,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX1=iADX  (pairname1,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar1=iSAR  (pairname1,tframe[x-1],Step_Psar,Max_Psar,0) ;
        
      PADX2=iADX  (pairname2,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX2=iADX  (pairname2,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar2=iSAR  (pairname2,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX3=iADX  (pairname3,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX3=iADX  (pairname3,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar3=iSAR  (pairname3,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX4=iADX  (pairname4,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX4=iADX  (pairname4,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar4=iSAR  (pairname4,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX5=iADX  (pairname5,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX5=iADX  (pairname5,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar5=iSAR  (pairname5,tframe[x-1],Step_Psar,Max_Psar,0) ;
        
      PADX6=iADX  (pairname6,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX6=iADX  (pairname6,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar6=iSAR  (pairname6,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX7=iADX  (pairname7,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX7=iADX  (pairname7,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar7=iSAR  (pairname7,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX8=iADX  (pairname8,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX8=iADX  (pairname8,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar8=iSAR  (pairname8,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX9=iADX  (pairname9,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX9=iADX  (pairname9,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar9=iSAR  (pairname9,tframe[x-1],Step_Psar,Max_Psar,0) ; 

      PADX10=iADX  (pairname10,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX10=iADX  (pairname10,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar10=iSAR  (pairname10,tframe[x-1],Step_Psar,Max_Psar,0) ;      

      PADX11=iADX  (pairname11,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX11=iADX  (pairname11,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar11=iSAR  (pairname11,tframe[x-1],Step_Psar,Max_Psar,0) ;
        
      PADX12=iADX  (pairname12,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX12=iADX  (pairname12,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar12=iSAR  (pairname12,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX13=iADX  (pairname13,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX13=iADX  (pairname13,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar13=iSAR  (pairname13,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX14=iADX  (pairname14,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX14=iADX  (pairname14,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar14=iSAR  (pairname14,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX15=iADX  (pairname15,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX15=iADX  (pairname15,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar15=iSAR  (pairname15,tframe[x-1],Step_Psar,Max_Psar,0) ;
        
      PADX16=iADX  (pairname16,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX16=iADX  (pairname16,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar16=iSAR  (pairname16,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX17=iADX  (pairname17,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX17=iADX  (pairname17,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar17=iSAR  (pairname17,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX18=iADX  (pairname18,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX18=iADX  (pairname18,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar18=iSAR  (pairname18,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX19=iADX  (pairname19,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX19=iADX  (pairname19,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar19=iSAR  (pairname19,tframe[x-1],Step_Psar,Max_Psar,0) ;

      PADX20=iADX  (pairname20,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX20=iADX  (pairname20,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar20=iSAR  (pairname20,tframe[x-1],Step_Psar,Max_Psar,0) ;

      PADX21=iADX  (pairname21,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX21=iADX  (pairname21,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar21=iSAR  (pairname21,tframe[x-1],Step_Psar,Max_Psar,0) ;
        
      PADX22=iADX  (pairname22,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX22=iADX  (pairname22,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar22=iSAR  (pairname22,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX23=iADX  (pairname23,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX23=iADX  (pairname23,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar23=iSAR  (pairname23,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX24=iADX  (pairname24,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX24=iADX  (pairname24,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar24=iSAR  (pairname24,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX25=iADX  (pairname25,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX25=iADX  (pairname25,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar25=iSAR  (pairname25,tframe[x-1],Step_Psar,Max_Psar,0) ;
        
      PADX26=iADX  (pairname26,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX26=iADX  (pairname26,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar26=iSAR  (pairname26,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX27=iADX  (pairname27,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX27=iADX  (pairname27,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar27=iSAR  (pairname27,tframe[x-1],Step_Psar,Max_Psar,0) ;
      
      PADX28=iADX  (pairname28,tframe[x-1],ADX_Period ,ADX_Price,1,0);
      NADX28=iADX  (pairname28,tframe[x-1],ADX_Period ,ADX_Price,2,0);
      Psar28=iSAR  (pairname28,tframe[x-1],Step_Psar,Max_Psar,0) ;
      // get indicators data end
      
      // Get Rules Result begin  
      if       (Psar1 < iClose(pairname1,tframe[x-1],0) && PADX1 > NADX1)  {IndVal1[x-1]  =  1;}
      else if  (Psar1 > iClose(pairname1,tframe[x-1],0) && NADX1 > PADX1)  {IndVal1[x-1]  =  -1;}
      else                                                                 {IndVal1[x-1]  =  0;}
   
      if       (Psar2 < iClose(pairname2,tframe[x-1],0) && PADX2 > NADX2)  {IndVal2[x-1]  =  1;}
      else if  (Psar2 > iClose(pairname2,tframe[x-1],0) && NADX2 > PADX2)  {IndVal2[x-1]  =  -1;}
      else                                                                 {IndVal2[x-1]  =  0;}
   
      if       (Psar3 < iClose(pairname3,tframe[x-1],0) && PADX3 > NADX3)  {IndVal3[x-1]  =  1;}
      else if  (Psar3 > iClose(pairname3,tframe[x-1],0) && NADX3 > PADX3)  {IndVal3[x-1]  =  -1;}
      else                                                                 {IndVal3[x-1]  =  0;}
      
      if       (Psar4 < iClose(pairname4,tframe[x-1],0) && PADX4 > NADX4)  {IndVal4[x-1]  =  1;}
      else if  (Psar4 > iClose(pairname4,tframe[x-1],0) && NADX4 > PADX4)  {IndVal4[x-1]  =  -1;}
      else                                                                 {IndVal4[x-1]  =  0;}
      
      if       (Psar5 < iClose(pairname5,tframe[x-1],0) && PADX5 > NADX5)  {IndVal5[x-1]  =  1;}
      else if  (Psar5 > iClose(pairname5,tframe[x-1],0) && NADX5 > PADX5)  {IndVal5[x-1]  =  -1;}
      else                                                                 {IndVal5[x-1]  =  0;}
   
      if       (Psar6 < iClose(pairname6,tframe[x-1],0) && PADX6 > NADX6)  {IndVal6[x-1]  =  1;}
      else if  (Psar6 > iClose(pairname6,tframe[x-1],0) && NADX6 > PADX6)  {IndVal6[x-1]  =  -1;}
      else                                                                 {IndVal6[x-1]  =  0;}
   
      if       (Psar7 < iClose(pairname7,tframe[x-1],0) && PADX7 > NADX7)  {IndVal7[x-1]  =  1;}
      else if  (Psar7 > iClose(pairname7,tframe[x-1],0) && NADX7 > PADX7)  {IndVal7[x-1]  =  -1;}
      else                                                                 {IndVal7[x-1]  =  0;}
      
      if       (Psar8 < iClose(pairname8,tframe[x-1],0) && PADX8 > NADX8)  {IndVal8[x-1]  =  1;}
      else if  (Psar8 > iClose(pairname8,tframe[x-1],0) && NADX8 > PADX8)  {IndVal8[x-1]  =  -1;}
      else                                                                 {IndVal8[x-1]  =  0;}
      
      if       (Psar9 < iClose(pairname9,tframe[x-1],0) && PADX9 > NADX9)  {IndVal9[x-1]  =  1;}
      else if  (Psar9 > iClose(pairname9,tframe[x-1],0) && NADX9 > PADX9)  {IndVal9[x-1]  =  -1;}
      else                                                                 {IndVal9[x-1]  =  0;}

      if       (Psar10 < iClose(pairname10,tframe[x-1],0) && PADX10 > NADX10)  {IndVal10[x-1]  =  1;}
      else if  (Psar10 > iClose(pairname10,tframe[x-1],0) && NADX10 > PADX10)  {IndVal10[x-1]  =  -1;}
      else                                                                     {IndVal10[x-1]  =  0;}

      if       (Psar11 < iClose(pairname11,tframe[x-1],0) && PADX11 > NADX11)  {IndVal11[x-1]  =  1;}
      else if  (Psar11 > iClose(pairname11,tframe[x-1],0) && NADX11 > PADX11)  {IndVal11[x-1]  =  -1;}
      else                                                                     {IndVal11[x-1]  =  0;}
   
      if       (Psar12 < iClose(pairname12,tframe[x-1],0) && PADX12 > NADX12)  {IndVal12[x-1]  =  1;}
      else if  (Psar12 > iClose(pairname12,tframe[x-1],0) && NADX12 > PADX12)  {IndVal12[x-1]  =  -1;}
      else                                                                     {IndVal12[x-1]  =  0;}
   
      if       (Psar13 < iClose(pairname13,tframe[x-1],0) && PADX13 > NADX13)  {IndVal13[x-1]  =  1;}
      else if  (Psar13 > iClose(pairname13,tframe[x-1],0) && NADX13 > PADX13)  {IndVal13[x-1]  =  -1;}
      else                                                                     {IndVal13[x-1]  =  0;}
      
      if       (Psar14 < iClose(pairname14,tframe[x-1],0) && PADX14 > NADX14)  {IndVal14[x-1]  =  1;}
      else if  (Psar14 > iClose(pairname14,tframe[x-1],0) && NADX14 > PADX14)  {IndVal14[x-1]  =  -1;}
      else                                                                     {IndVal14[x-1]  =  0;}
      
      if       (Psar15 < iClose(pairname15,tframe[x-1],0) && PADX15 > NADX15)  {IndVal15[x-1]  =  1;}
      else if  (Psar15 > iClose(pairname15,tframe[x-1],0) && NADX15 > PADX15)  {IndVal15[x-1]  =  -1;}
      else                                                                     {IndVal15[x-1]  =  0;}
   
      if       (Psar16 < iClose(pairname16,tframe[x-1],0) && PADX16 > NADX15)  {IndVal16[x-1]  =  1;}
      else if  (Psar16 > iClose(pairname16,tframe[x-1],0) && NADX16 > PADX15)  {IndVal16[x-1]  =  -1;}
      else                                                                     {IndVal16[x-1]  =  0;}
   
      if       (Psar17 < iClose(pairname17,tframe[x-1],0) && PADX17 > NADX17)  {IndVal17[x-1]  =  1;}
      else if  (Psar17 > iClose(pairname17,tframe[x-1],0) && NADX17 > PADX17)  {IndVal17[x-1]  =  -1;}
      else                                                                     {IndVal17[x-1]  =  0;}
      
      if       (Psar18 < iClose(pairname18,tframe[x-1],0) && PADX18 > NADX18)  {IndVal18[x-1]  =  1;}
      else if  (Psar18 > iClose(pairname18,tframe[x-1],0) && NADX18 > PADX18)  {IndVal18[x-1]  =  -1;}
      else                                                                     {IndVal18[x-1]  =  0;}
      
      if       (Psar19 < iClose(pairname19,tframe[x-1],0) && PADX19 > NADX19)  {IndVal19[x-1]  =  1;}
      else if  (Psar19 > iClose(pairname19,tframe[x-1],0) && NADX19 > PADX19)  {IndVal19[x-1]  =  -1;}
      else                                                                     {IndVal19[x-1]  =  0;}

      if       (Psar20 < iClose(pairname20,tframe[x-1],0) && PADX20 > NADX20)  {IndVal20[x-1]  =  1;}
      else if  (Psar20 > iClose(pairname20,tframe[x-1],0) && NADX20 > PADX20)  {IndVal20[x-1]  =  -1;}
      else                                                                     {IndVal20[x-1]  =  0;}

      if       (Psar21 < iClose(pairname21,tframe[x-1],0) && PADX21 > NADX21)  {IndVal21[x-1]  =  1;}
      else if  (Psar21 > iClose(pairname21,tframe[x-1],0) && NADX21 > PADX21)  {IndVal21[x-1]  =  -1;}
      else                                                                     {IndVal21[x-1]  =  0;}
    
      if       (Psar22 < iClose(pairname22,tframe[x-1],0) && PADX22 > NADX22)  {IndVal22[x-1]  =  1;}
      else if  (Psar22 > iClose(pairname22,tframe[x-1],0) && NADX22 > PADX22)  {IndVal22[x-1]  =  -1;}
      else                                                                     {IndVal22[x-1]  =  0;}
   
      if       (Psar23 < iClose(pairname23,tframe[x-1],0) && PADX23 > NADX23)  {IndVal23[x-1]  =  1;}
      else if  (Psar23 > iClose(pairname23,tframe[x-1],0) && NADX23 > PADX23)  {IndVal23[x-1]  =  -1;}
      else                                                                     {IndVal23[x-1]  =  0;}
       
      if       (Psar24 < iClose(pairname24,tframe[x-1],0) && PADX24 > NADX24)  {IndVal24[x-1]  =  1;}
      else if  (Psar24 > iClose(pairname24,tframe[x-1],0) && NADX24 > PADX24)  {IndVal24[x-1]  =  -1;}
      else                                                                     {IndVal24[x-1]  =  0;}
      
      if       (Psar25 < iClose(pairname25,tframe[x-1],0) && PADX25 > NADX25)  {IndVal25[x-1]  =  1;}
      else if  (Psar25 > iClose(pairname25,tframe[x-1],0) && NADX25 > PADX25)  {IndVal25[x-1]  =  -1;}
      else                                                                     {IndVal25[x-1]  =  0;}
   
      if       (Psar26 < iClose(pairname25,tframe[x-1],0) && PADX26 > NADX26)  {IndVal26[x-1]  =  1;}
      else if  (Psar26 > iClose(pairname25,tframe[x-1],0) && NADX26 > PADX26)  {IndVal26[x-1]  =  -1;}
      else                                                                     {IndVal26[x-1]  =  0;}
   
      if       (Psar27 < iClose(pairname27,tframe[x-1],0) && PADX27 > NADX27)  {IndVal27[x-1]  =  1;}
      else if  (Psar27 > iClose(pairname27,tframe[x-1],0) && NADX27 > PADX27)  {IndVal27[x-1]  =  -1;}
      else                                                                     {IndVal27[x-1]  =  0;}
       
      if       (Psar28 < iClose(pairname28,tframe[x-1],0) && PADX28 > NADX28)  {IndVal28[x-1]  =  1;}
      else if  (Psar28 > iClose(pairname28,tframe[x-1],0) && NADX28 > PADX28)  {IndVal28[x-1]  =  -1;}
      else                                                                     {IndVal28[x-1]  =  0;}
      // Get Rules Result end
      }
      // Draw Result  begin
   for(int y=1;y<tfnumber+1;y++)
      {
         if (IndVal1[y-1]==-1 )  ObjectSetText("Ind"+y+pairname1,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal1[y-1]==0  )  ObjectSetText("Ind"+y+pairname1,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal1[y-1]==1  )  ObjectSetText("Ind"+y+pairname1,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal2[y-1]==-1 )  ObjectSetText("Ind"+y+pairname2,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal2[y-1]==0  )  ObjectSetText("Ind"+y+pairname2,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal2[y-1]==1  )  ObjectSetText("Ind"+y+pairname2,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal3[y-1]==-1 )  ObjectSetText("Ind"+y+pairname3,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal3[y-1]==0  )  ObjectSetText("Ind"+y+pairname3,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal3[y-1]==1  )  ObjectSetText("Ind"+y+pairname3,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal4[y-1]==-1 )  ObjectSetText("Ind"+y+pairname4,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal4[y-1]==0  )  ObjectSetText("Ind"+y+pairname4,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal4[y-1]==1  )  ObjectSetText("Ind"+y+pairname4,CharToStr(154),15,"Wingdings",UpColor);
         
         if (IndVal5[y-1]==-1 )  ObjectSetText("Ind"+y+pairname5,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal5[y-1]==0  )  ObjectSetText("Ind"+y+pairname5,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal5[y-1]==1  )  ObjectSetText("Ind"+y+pairname5,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal6[y-1]==-1 )  ObjectSetText("Ind"+y+pairname6,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal6[y-1]==0  )  ObjectSetText("Ind"+y+pairname6,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal6[y-1]==1  )  ObjectSetText("Ind"+y+pairname6,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal7[y-1]==-1 )  ObjectSetText("Ind"+y+pairname7,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal7[y-1]==0  )  ObjectSetText("Ind"+y+pairname7,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal7[y-1]==1  )  ObjectSetText("Ind"+y+pairname7,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal8[y-1]==-1 )  ObjectSetText("Ind"+y+pairname8,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal8[y-1]==0  )  ObjectSetText("Ind"+y+pairname8,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal8[y-1]==1  )  ObjectSetText("Ind"+y+pairname8,CharToStr(154),15,"Wingdings",UpColor);
         
         if (IndVal9[y-1]==-1 )  ObjectSetText("Ind"+y+pairname9,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal9[y-1]==0  )  ObjectSetText("Ind"+y+pairname9,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal9[y-1]==1  )  ObjectSetText("Ind"+y+pairname9,CharToStr(154),15,"Wingdings",UpColor);

         if (IndVal10[y-1]==-1 )  ObjectSetText("Ind"+y+pairname10,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal10[y-1]==0  )  ObjectSetText("Ind"+y+pairname10,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal10[y-1]==1  )  ObjectSetText("Ind"+y+pairname10,CharToStr(154),15,"Wingdings",UpColor);
         
         if (IndVal11[y-1]==-1 )  ObjectSetText("Ind"+y+pairname11,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal11[y-1]==0  )  ObjectSetText("Ind"+y+pairname11,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal11[y-1]==1  )  ObjectSetText("Ind"+y+pairname11,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal12[y-1]==-1 )  ObjectSetText("Ind"+y+pairname12,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal12[y-1]==0  )  ObjectSetText("Ind"+y+pairname12,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal12[y-1]==1  )  ObjectSetText("Ind"+y+pairname12,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal13[y-1]==-1 )  ObjectSetText("Ind"+y+pairname13,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal13[y-1]==0  )  ObjectSetText("Ind"+y+pairname13,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal13[y-1]==1  )  ObjectSetText("Ind"+y+pairname13,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal14[y-1]==-1 )  ObjectSetText("Ind"+y+pairname14,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal14[y-1]==0  )  ObjectSetText("Ind"+y+pairname14,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal14[y-1]==1  )  ObjectSetText("Ind"+y+pairname14,CharToStr(154),15,"Wingdings",UpColor);
         
         if (IndVal15[y-1]==-1 )  ObjectSetText("Ind"+y+pairname15,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal15[y-1]==0  )  ObjectSetText("Ind"+y+pairname15,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal15[y-1]==1  )  ObjectSetText("Ind"+y+pairname15,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal16[y-1]==-1 )  ObjectSetText("Ind"+y+pairname16,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal16[y-1]==0  )  ObjectSetText("Ind"+y+pairname16,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal16[y-1]==1  )  ObjectSetText("Ind"+y+pairname16,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal17[y-1]==-1 )  ObjectSetText("Ind"+y+pairname17,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal17[y-1]==0  )  ObjectSetText("Ind"+y+pairname17,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal17[y-1]==1  )  ObjectSetText("Ind"+y+pairname17,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal18[y-1]==-1 )  ObjectSetText("Ind"+y+pairname18,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal18[y-1]==0  )  ObjectSetText("Ind"+y+pairname18,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal18[y-1]==1  )  ObjectSetText("Ind"+y+pairname18,CharToStr(154),15,"Wingdings",UpColor);
         
         if (IndVal19[y-1]==-1 )  ObjectSetText("Ind"+y+pairname19,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal19[y-1]==0  )  ObjectSetText("Ind"+y+pairname19,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal19[y-1]==1  )  ObjectSetText("Ind"+y+pairname19,CharToStr(154),15,"Wingdings",UpColor);

         if (IndVal20[y-1]==-1 )  ObjectSetText("Ind"+y+pairname20,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal20[y-1]==0  )  ObjectSetText("Ind"+y+pairname20,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal20[y-1]==1  )  ObjectSetText("Ind"+y+pairname20,CharToStr(154),15,"Wingdings",UpColor);

         if (IndVal21[y-1]==-1 )  ObjectSetText("Ind"+y+pairname21,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal21[y-1]==0  )  ObjectSetText("Ind"+y+pairname21,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal21[y-1]==1  )  ObjectSetText("Ind"+y+pairname21,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal22[y-1]==-1 )  ObjectSetText("Ind"+y+pairname22,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal22[y-1]==0  )  ObjectSetText("Ind"+y+pairname22,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal22[y-1]==1  )  ObjectSetText("Ind"+y+pairname22,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal23[y-1]==-1 )  ObjectSetText("Ind"+y+pairname23,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal23[y-1]==0  )  ObjectSetText("Ind"+y+pairname23,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal23[y-1]==1  )  ObjectSetText("Ind"+y+pairname23,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal24[y-1]==-1 )  ObjectSetText("Ind"+y+pairname24,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal24[y-1]==0  )  ObjectSetText("Ind"+y+pairname24,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal24[y-1]==1  )  ObjectSetText("Ind"+y+pairname24,CharToStr(154),15,"Wingdings",UpColor);
         
         if (IndVal25[y-1]==-1 )  ObjectSetText("Ind"+y+pairname25,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal25[y-1]==0  )  ObjectSetText("Ind"+y+pairname25,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal25[y-1]==1  )  ObjectSetText("Ind"+y+pairname25,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal26[y-1]==-1 )  ObjectSetText("Ind"+y+pairname26,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal26[y-1]==0  )  ObjectSetText("Ind"+y+pairname26,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal26[y-1]==1  )  ObjectSetText("Ind"+y+pairname26,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal27[y-1]==-1 )  ObjectSetText("Ind"+y+pairname27,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal27[y-1]==0  )  ObjectSetText("Ind"+y+pairname27,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal27[y-1]==1  )  ObjectSetText("Ind"+y+pairname27,CharToStr(154),15,"Wingdings",UpColor);
      
         if (IndVal28[y-1]==-1 )  ObjectSetText("Ind"+y+pairname28,CharToStr(155),15,"Wingdings",DownColor);
         if (IndVal28[y-1]==0  )  ObjectSetText("Ind"+y+pairname28,CharToStr(91),15,"Wingdings",FlatColor);
         if (IndVal28[y-1]==1  )  ObjectSetText("Ind"+y+pairname28,CharToStr(154),15,"Wingdings",UpColor);
      }  
      // Draw Result end    
   
//----
   return(0);
  }
//+------------------------------------------------------------------+